//filename: main.cpp

#include <windows.h>
#include <stdlib.h>
#include <wtypes.h>
#include <conio.h>
#include <stdio.h>
#include "main.h"


BOOLEAN LoadLibraries()
{
	hLib30x = LoadLibrary ("LL_USB.dll");
    if(!hLib30x) return FALSE;
    return TRUE;
}

BOOLEAN InitLibFuncs()
{  
	EX_Connect = (P_DLL_EX_CONNECT)GetProcAddress(hLib30x, "EX_Connect");
	if(!EX_Connect) return FALSE;
	EX_SetPolledModeChan =  (P_DLL_EX_SET_CHAN)GetProcAddress(hLib30x, "EX_SetPolledModeChan");
	if(!EX_SetPolledModeChan) return FALSE;
	EX_GetOneConversion = (P_DLL_EX_GET_ONE_CONVERSION)GetProcAddress(hLib30x, "EX_GetOneConversion");
	if(!EX_GetOneConversion) return FALSE;

    return TRUE;
}


int __cdecl main()
{
	USHORT usDevID = 0; double dblMillivolts;
	BOOLEAN fRetVal = FALSE; BOOLEAN fRedraw = FALSE;

	if(!LoadLibraries()){ printf("Failed to load libraries"); getch(); return 0;}
	printf("Success loading libraries\n");

	if(!InitLibFuncs())
	{ printf("Failed to find required functions"); getch(); return 0;}

	printf("Success finding required functions\nConnecting -  please wait. . .");
	fRetVal = EX_Connect(&usDevID);
	if(!(fRetVal | usDevID))
	{ printf("Failed  EX_Connect()"); getch(); return 0; }

	char cUserInputVal = NULL; char szOutVal[32], szTempBuff[32]; int iKeyChar = 0;  

	while(true)
	{
		setMainScreen();
		fRedraw = FALSE;

		while((cUserInputVal != 'Q') && (cUserInputVal != 'q') && (cUserInputVal != 27) && (!fRedraw))
		{
			cUserInputVal = (char)getch();
			switch(cUserInputVal)
			{
				case 'Q': case 'q': case 27:
					printf("\nDisconnecting and exiting, please wait ....\n"); break;
				case 'R': case 'r':
					fRedraw = TRUE; system("cls"); break;
				case 'C': case 'c':
					sprintf(szOutVal, ""); printf("\nenter channel: ");
					while(TRUE)
					{
						iKeyChar = getche(); if(iKeyChar == 13) break;
						if(((iKeyChar == 8) || (iKeyChar < 48) || (iKeyChar > 57))) 
						{
							setMainScreen(); 
							 if( (strlen(szOutVal) > 0) && (iKeyChar == 8)) szOutVal[strlen(szOutVal)-1] = 0; 
							printf("\nenter channel: %s", szOutVal);
							continue;
						}
						sprintf(szTempBuff, "%u", ((BYTE)iKeyChar) - '0');
						strcat(szOutVal, szTempBuff); if(strlen(szOutVal) == 1) break;
					}
					
					if(((UINT)(atoi(szOutVal))) > 7)
					{ printf("\nvalue entered greater than 7. New value: 7"); sprintf(szOutVal, "7"); }
					
					if(!EX_SetPolledModeChan(usDevID, (BYTE)(atoi(szOutVal)))) printf("\nfailed to send channel\n"); 
					else printf("\nchannel sent: %d\n", (BYTE)(atoi(szOutVal)));
					sprintf(szOutVal, ""); break;
				case 'V': case 'v':
					if(!EX_GetOneConversion(usDevID, &dblMillivolts)) printf("\nfailed to get voltage\n"); 
					else(printf("voltage: %2.6lf\n", dblMillivolts / 1000.0)); break;
			}
		}
		if(!fRedraw) break;
	}

	return 1;
}
void setMainScreen(void)
{
	system("cls");
		printf("\nINITIALIZED\nPress one of the following keys:\n"
			"'Q' quit\n"
			"'R' redraw screen\n"
			"'C' set the channel\n"
			"'V' get one voltage - it will come from preconfigured channel\n"
			);
}

